* modified build script to find out the version the way we do it now.
[citadel.git] / citadel / debian / citadel.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          skeleton
4 # Required-Start:    $local_fs $remote_fs
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Example initscript
9 # Description:       This file should be used to construct scripts to be
10 #                    placed in /etc/init.d.
11 ### END INIT INFO
12
13 # Author: Foo Bar <foobar@baz.org>
14 #
15 # Please remove the "Author" lines above and replace them
16 # with your own name if you copy and modify this script.
17
18 # Do NOT "set -e"
19
20 # PATH should only include /usr/* if it runs after the mountnfs.sh script
21 RUNDIR=/var/run/citadel
22 PATH=/sbin:/usr/sbin:/bin:/usr/bin
23 DESC="Citadel Groupware "
24 NAME=citserver
25 DAEMON=/usr/sbin/$NAME
26 CTDLSVC=/usr/lib/citadel-server/ctdlsvc
27 DAEMON_ARGS=" -x3 -lmail -t/dev/null"
28 PIDFILE=$RUNDIR/$NAME.pid
29 SCRIPTNAME=/etc/init.d/citadel
30 SENDCOMMAND=/usr/sbin/sendcommand
31
32
33 # Exit if the package is not installed
34 [ -x "$DAEMON" ] || exit 0
35
36 # Read configuration variable file if it is present
37 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
38
39 # Load the VERBOSE setting and other rcS variables
40 . /lib/init/vars.sh
41
42 # Define LSB log_* functions.
43 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
44 . /lib/lsb/init-functions
45
46 #
47 # Function that starts the daemon/service
48 #
49 do_start()
50 {
51         # for ubuntu: check our volatile dirs.
52         if test ! -d $RUNDIR; then
53             mkdir -p $RUNDIR
54         fi
55         # Return
56         #   0 if daemon has been started
57         #   1 if daemon was already running
58         #   2 if daemon could not be started
59         if $CTDLSVC $PIDFILE $DAEMON \
60                 $DAEMON_ARGS ; then
61             return 0
62         else
63             return 2
64         fi
65         # Add code here, if necessary, that waits for the process to be ready
66         # to handle requests from services started subsequently which depend
67         # on this one.  As a last resort, sleep for some time.
68 }
69
70 #
71 # Function that stops the daemon/service
72 #
73 do_stop()
74 {
75         # Return
76         #   0 if daemon has been stopped
77         #   1 if daemon was already stopped
78         #   2 if daemon could not be stopped
79         #   other if a failure occurred
80         if $SENDCOMMAND "DOWN" >/dev/null 2>&1 ; then
81             rm -f $PIDFILE
82             return 0
83         else
84             rm -f $PIDFILE
85             return 2
86         fi
87
88         #while test -d /proc/`cat $PIDFILE`; do
89         #    /usr/bin/printf  '.'
90         #    /bin/sleep 1
91         #done
92  
93         #start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
94         #RETVAL="$?"
95         #[ "$RETVAL" = 2 ] && return 2
96         # Wait for children to finish too if this is a daemon that forks
97         # and if the daemon is only ever run from this initscript.
98         # If the above conditions are not satisfied then add some other code
99         # that waits for the process to drop all resources that could be
100         # needed by services started subsequently.  A last resort is to
101         # sleep for some time.
102         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
103         #[ "$?" = 2 ] && return 2
104         # Many daemons don't delete their pidfiles when they exit.
105         # rm -f $PIDFILE
106 }
107
108 #
109 # Function that sends a SIGHUP to the daemon/service
110 #
111 do_reload() {
112         #
113         # If the daemon can reload its configuration without
114         # restarting (for example, when it is sent a SIGHUP),
115         # then implement that here.
116         #
117 #       start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
118         do_stop
119         do_start
120         return 0
121 }
122
123 case "$1" in
124   start)
125         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
126         do_start
127         case "$?" in
128                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
129                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
130         esac
131         ;;
132   stop)
133         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
134         do_stop
135         case "$?" in
136                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
137                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
138         esac
139         ;;
140   #reload|force-reload)
141         #
142         # If do_reload() is not implemented then leave this commented out
143         # and leave 'force-reload' as an alias for 'restart'.
144         #
145         #log_daemon_msg "Reloading $DESC" "$NAME"
146         #do_reload
147         #log_end_msg $?
148         #;;
149   restart|force-reload)
150         #
151         # If the "reload" option is implemented then remove the
152         # 'force-reload' alias
153         #
154         log_daemon_msg "Restarting $DESC" "$NAME"
155         do_stop
156         case "$?" in
157           0|1)
158                 do_start
159                 case "$?" in
160                         0) log_end_msg 0 ;;
161                         1) log_end_msg 1 ;; # Old process is still running
162                         *) log_end_msg 1 ;; # Failed to start
163                 esac
164                 ;;
165           *)
166                 # Failed to stop
167                 log_end_msg 1
168                 ;;
169         esac
170         ;;
171   *)
172         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
173         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
174         exit 3
175         ;;
176 esac
177
178 :